<template>
  <div id="book-form">
    <form @submit.prevent="handleSubmit">

      <label>Book name</label>
      <input
        ref="first"
        type="text"
        :class="{ 'has-error': submitting && invalidName }"
        v-model="book.name"
        @focus="clearStatus"
        @keypress="clearStatus"
      >
      <label>Book Author</label>
      <input
        type="text"
        :class="{ 'has-error': submitting && invalidAuthor }"
        v-model="book.author"
        @focus="clearStatus"
      >

      <label>Book Price</label>
      <input
        type="number"
        :class="{ 'has-error': submitting && invalidNumber }"
        v-model="book.price"
        @focus="clearStatus"
      >
      <p
        v-if="error && submitting"
        class="error-message"
      >❗Please fill out all required fields</p>
      <p
        v-if="success"
        class="success-message"
      >✅ Book successfully added</p>
      <button>Add Book</button>
    </form>

  </div>
</template>

<script>
export default {
  name: 'book-form',

  //data is the component local state 
  data() {
    return {
      error: false,
      submitting: false,
      success: false,
      book: {
        name: '',
        author: '',
        price: '',
      }
    }
  },

  //computed properties relevant to the component
  computed: {
    invalidName() {
      return this.book.name === ''
    },
    invalidAuthor() {
      return this.book.author === ''
    },
    invalidPrice() {
      return this.book.price === ''
    },
    
  },

  //methods associated with the properties
  methods: {
    handleSubmit() {
      this.clearStatus()
      this.submitting = true
      if (this.invalidName || this.invalidAuthor || this.invalidPrice) {
        this.error = true
        return
      }
      this.$emit('add:book', this.book)
      this.$refs.first.focus()
      this.book = {
        name: '',
        author: '',
        price: '',
      }
      this.success = true
      this.error = false
      this.submitting = false
    },
    clearStatus() {
      this.success = false
      this.error = false
    }
  }}


  //watch component watchers
</script>

<style scoped>
form {
  margin-bottom: 2rem;
}
[class*="-message"] {
  font-weight: 500;
}
.error-message {
  color: #d33c40;
}
.success-message {
  color: #32a95d;
}
</style>